SELECT DISTINCT
    staff.p_site_key_n,
    staff.pm_key_n,
    person.p_partner_key_n,
    person.p_gender_c AS Gender,
    person.p_family_name_c AS Surname,
    person.p_first_name_c AS Firstname,
    partner.p_partner_short_name_c AS PartnerName,
    staff.pm_start_of_commitment_d,
    staff.pm_end_of_commitment_d,
    punitreceive.p_country_code_c AS ReceivingCountryCode
FROM PUB_pm_staff_data AS staff,
     PUB_p_person AS person,
     PUB_p_partner AS partner,
     PUB_p_unit AS punitreceive
WHERE person.p_partner_key_n = staff.p_partner_key_n
    AND person.p_partner_key_n = partner.p_partner_key_n
    AND punitreceive.p_partner_key_n = staff.pm_receiving_field_n
    AND partner.p_status_code_c = 'ACTIVE'
    AND EXISTS (SELECT * FROM PUB_pm_staff_data AS CurrentStaff
        WHERE CurrentStaff.p_partner_key_n = person.p_partner_key_n
        AND CurrentStaff.pm_start_of_commitment_d <= ?
        AND (CurrentStaff.pm_end_of_commitment_d >= ?
            OR CurrentStaff.pm_end_of_commitment_d IS NULL))
