SELECT DISTINCT
    person.p_partner_key_n AS PartnerKey,
    DAYOFYEAR(person.p_date_of_birth_d) AS DOBThisYear,
    person.p_date_of_birth_d AS DOB,
    person.p_gender_c AS Gender,
    person.p_family_name_c AS Surname,
    person.p_first_name_c AS Firstname,
    partner.p_partner_short_name_c AS PartnerName

{#IFDEF SELECTTYPES}
    , pptype.p_type_code_c
{#ENDIF SELECTTYPES}

    FROM PUB_p_person AS person,
        PUB_p_partner AS partner

{#IFDEF SELECTTYPES}
    , PUB_p_partner_type AS pptype
{#ENDIF SELECTTYPES}

{#IFDEF ONEPARTNER}
    WHERE person.p_partner_key_n = ?
        AND  partner.p_partner_key_n = ?
{#ENDIF ONEPARTNER}

{#IFDEF BYEXTRACT}
    , PUB_m_extract,
    PUB_m_extract_master
    WHERE PUB_m_extract.m_extract_id_i = PUB_m_extract_master.m_extract_id_i
        AND PUB_m_extract_master.m_extract_name_c = ?
        AND  person.p_partner_key_n = PUB_m_extract.p_partner_key_n
        AND  partner.p_partner_key_n = PUB_m_extract.p_partner_key_n
{#ENDIF BYEXTRACT}

{#IFDEF BYSTAFF}
    , PUB_pm_staff_data AS staff
    WHERE person.p_partner_key_n = staff.p_partner_key_n
        AND person.p_partner_key_n = partner.p_partner_key_n
        AND staff.pm_start_of_commitment_d <= ?
        AND (staff.pm_end_of_commitment_d >= ?
            OR staff.pm_end_of_commitment_d IS NULL)
        AND person.p_family_key_n IS NOT NULL
        AND partner.p_status_code_c = 'ACTIVE'
{#ENDIF BYSTAFF}

{#IFDEF BYFAMILYKEY}
    WHERE person.p_partner_key_n = partner.p_partner_key_n
        AND partner.p_status_code_c = 'ACTIVE'
        AND person.p_family_key_n = ?
{#ENDIF BYFAMILYKEY}

{#IFDEF SELECTTYPES}
    -- check type code
    AND person.p_partner_key_n = pptype.p_partner_key_n
    -- eg: AND (pptype.p_type_code_c = param_typecode[0] OR pptype.p_type_code_c = param_typecode[1])
    AND {#SELECTTYPES}
{#ENDIF SELECTTYPES}

{#IFDEF WITHDATERANGE}
    -- check date range
    AND DAYOFYEAR(person.p_date_of_birth_d) >= DAYOFYEAR(?)
    AND DAYOFYEAR(person.p_date_of_birth_d) <= DAYOFYEAR(?)
{#ENDIF WITHDATERANGE}

{#IFDEF WITHOUTDATERANGE}
    -- exclude date range
    AND (DAYOFYEAR(person.p_date_of_birth_d) <= DAYOFYEAR(?)) OR (DAYOFYEAR(person.p_date_of_birth_d) >= DAYOFYEAR(?)))
{#ENDIF WITHOUTDATERANGE}

ORDER BY DOBThisYear